﻿Module AI

#Region "Globální proměnné"

    ''' <summary>
    ''' Hodnota důležitá pro funci benchmarkovací funkce. Ukládá počet průběhů funkce.
    ''' </summary>
    ''' <remarks></remarks>
    Public PocetPrubehuHodnoticiFunkce As Long

    ''' <summary>
    ''' Hodnota udávající AI co hraje.
    ''' </summary>
    ''' <remarks></remarks>
    Public GlobalnePouzivanaAI As Byte

    ''' <summary>
    ''' Hrací hloubka minimaxu (o 1 menší než doopravdy).
    ''' </summary>
    ''' <remarks></remarks>
    Public HraciHloubka_Minimax As Byte = 1

    ''' <summary>
    ''' Hrací hloubka alfabety (o 1 menší než doopravdy).
    ''' </summary>
    ''' <remarks></remarks>
    Public HraciHloubka_Alfabeta As Byte = 2

#End Region










#Region "Převod údajů proměnných na text"

    ''' <summary>
    ''' Funkce převádějí proměnnou Rotace(Byte) na odpovídající text.
    ''' </summary>
    ''' <param name="Rotace">Value of Byte</param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function TextRotace(ByVal Rotace As Byte) As String

        Select Case Rotace

            Case 0
                Return "1.kvadrant doprava"
            Case 1
                Return "1.kvadrant doleva"
            Case 2
                Return "2.kvadrant doprava"
            Case 3
                Return "2.kvadrant doleva"
            Case 4
                Return "3.kvadrant doprava"
            Case 5
                Return "3.kvadrant doleva"
            Case 6
                Return "4.kvadrant doprava"
            Case 7
                Return "4.kvadrant doleva"
            Case Else
                Alert_Error1()
                Return ""

        End Select

    End Function

#End Region

#Region "Zápis Hodnocení Tahů"

    ''' <summary>
    ''' Procedura zapisující výsledky průběhu hodnocení do listu viditelného pro uživatele. Určena pro Naivní AI.
    ''' </summary>
    ''' <param name="Tahy">Array(PocetMoznychTahu) of Short</param>
    ''' <param name="Hodnota">Array(PocetMoznychTahu) of Single</param>
    ''' <remarks></remarks>
    Public Sub ZapisTahy(ByVal Tahy() As Short, ByVal Hodnota() As Single)

        AI_GUI.AI_List.Items.Clear()

        For a As Short = 0 To Tahy.Length - 1

            Dim Zaznam As New ListViewItem

            Zaznam.Text = Hodnota(a)


            Dim X, Y, Tah, Rotace As Byte

            Rotace = Tahy(a) \ 36
            Tah = Tahy(a) - 36 * Rotace

            Y = Tah \ 6
            X = Tah - Y * 6

            Zaznam.SubItems.Add("Tah - X:" & (X + 1) & " Y:" & (Y + 1) & " -- Rotace - " & TextRotace(Rotace))

            AI_GUI.AI_List.Items.Add(Zaznam)

        Next
    End Sub

#End Region


#Region "AI Ovladač"

    Public Sub AI_CommitMove_P1(ByVal AI_123 As Byte)

        '''''''''''''
        UInteligence.PrevezmiStavHry(Deska)
        '''''''''''''

        Dim BestMove As Short

        Select Case AI_123
            Case 1
                BestMove = UInteligence.NaivniAI_NejlepsiTah(Deska.HracNaTahu, True)
            Case 2
                BestMove = UInteligence.MinMaxAI_NejlepsiTah(HraciHloubka_Minimax, Deska.HracNaTahu)
            Case 3
                BestMove = UInteligence.AlfaBetaAI_NejlepsiTah(HraciHloubka_Alfabeta, Deska.HracNaTahu)
        End Select

        Dim Rotation As Byte = BestMove \ 36
        Dim Move As Byte = BestMove - 36 * Rotation

        Deska.Pole(Move) = Deska.HracNaTahu

        Deska.VykresliPole(Move, Deska.Pole(Move))

        Notation_WriteMove("w", Move - (6 * (Move \ 6)), Move \ 6)

        If PD_Check_For_5_FINAL(Deska.HracNaTahu) = True Then
            If Deska.CernyCekaNaVyhru = False Then
                Alert_Victory("w")
                HaltGame()
                Exit Sub
            Else
                Alert_Draw()
                HaltGame()
                Exit Sub
            End If
        Else
            If Deska.CernyCekaNaVyhru = False Then
                Deska.BilyRotoval = False
                Deska.BilyTahnul = True
            Else
                Alert_Victory("b")
                HaltGame()
                Exit Sub
            End If
        End If

        Application.DoEvents()

        Select Case Rotation
            Case 0
                Deska.Rotuj_Q1R()
                Deska.ShowRotating_Q1R()
            Case 1
                Deska.Rotuj_Q1L()
                Deska.ShowRotating_Q1L()
            Case 2
                Deska.Rotuj_Q2R()
                Deska.ShowRotating_Q2R()
            Case 3
                Deska.Rotuj_Q2L()
                Deska.ShowRotating_Q2L()
            Case 4
                Deska.Rotuj_Q3R()
                Deska.ShowRotating_Q3R()
            Case 5
                Deska.Rotuj_Q3L()
                Deska.ShowRotating_Q3L()
            Case 6
                Deska.Rotuj_Q4R()
                Deska.ShowRotating_Q4R()
            Case 7
                Deska.Rotuj_Q4L()
                Deska.ShowRotating_Q4L()
        End Select

        Deska.BilyRotoval = True
        Deska.CernyTahnul = False
        'Deska.HracNaTahu *= -1 'NOVA LINKA

        Deska.VykresliSoucasnouDesku()

        Application.DoEvents()

        If Deska.HracCerny = 1 Then
            'AI MODULE
            Main.AI_TimeToMove2.Enabled = True
        End If
    End Sub

    Public Sub AI_CommitMove_P2(ByVal AI_123 As Byte)

        Dim BestMove As Short

        '''''''''''''
        UInteligence.PrevezmiStavHry(Deska)
        '''''''''''''

        Select Case AI_123
            Case 1
                BestMove = UInteligence.NaivniAI_NejlepsiTah(Deska.HracNaTahu, True)
            Case 2
                BestMove = UInteligence.MinMaxAI_NejlepsiTah(HraciHloubka_Minimax, Deska.HracNaTahu)
            Case 3
                BestMove = UInteligence.AlfaBetaAI_NejlepsiTah(HraciHloubka_Alfabeta, Deska.HracNaTahu)
        End Select

        Dim Rotation As Byte = BestMove \ 36
        Dim Move As Byte = BestMove - 36 * Rotation

        Deska.Pole(Move) = Deska.HracNaTahu

        Deska.VykresliPole(Move, Deska.Pole(Move))

        Notation_WriteMove("b", Move - (6 * (Move \ 6)), Move \ 6)

        If PD_Check_For_5_FINAL(Deska.HracNaTahu) = True Then
            If Deska.BilyCekaNaVyhru = False Then
                Alert_Victory("b")
                HaltGame()
                Exit Sub
            Else
                Alert_Draw()
                HaltGame()
                Exit Sub
            End If
        Else
            If Deska.BilyCekaNaVyhru = False Then
                Deska.CernyRotoval = False
                Deska.CernyTahnul = True
            Else
                Alert_Victory("w")
                HaltGame()
                Exit Sub
            End If
        End If

        Deska.VykresliSoucasnouDesku()

        Application.DoEvents()

        Select Case Rotation
            Case 0
                Deska.Rotuj_Q1R()
                Deska.ShowRotating_Q1R()
            Case 1
                Deska.Rotuj_Q1L()
                Deska.ShowRotating_Q1L()
            Case 2
                Deska.Rotuj_Q2R()
                Deska.ShowRotating_Q2R()
            Case 3
                Deska.Rotuj_Q2L()
                Deska.ShowRotating_Q2L()
            Case 4
                Deska.Rotuj_Q3R()
                Deska.ShowRotating_Q3R()
            Case 5
                Deska.Rotuj_Q3L()
                Deska.ShowRotating_Q3L()
            Case 6
                Deska.Rotuj_Q4R()
                Deska.ShowRotating_Q4R()
            Case 7
                Deska.Rotuj_Q4L()
                Deska.ShowRotating_Q4L()
        End Select

        'Deska.HracNaTahu *= -1 'NOVA LINKA

        Deska.CernyRotoval = True
        Deska.BilyTahnul = False

        Deska.VykresliSoucasnouDesku()

        Application.DoEvents()

        If Deska.HracBily = 1 Then
            'AI MODULE
            Main.AI_TimeToMove1.Enabled = True
        End If
    End Sub

#End Region







    Public Sub BackUp_Board(ByVal IniBoard() As SByte, ByRef BackUp() As SByte)

        For a As Byte = 0 To 35
            BackUp(a) = IniBoard(a)
        Next

    End Sub

    Public Sub Rotate_from_Backup(ByVal BackUpField_Value As SByte, ByRef BoardPosition As SByte)

        If BackUpField_Value = 1 Then
            BoardPosition = 1
        ElseIf BackUpField_Value = -1 Then
            BoardPosition = -1
        Else
            BoardPosition = 0
        End If


    End Sub
    




End Module
