﻿Public Class ZaznamHry

    ''PROPERTIES''

    Private _Datum As String
    ''' <summary>
    ''' Kdy se hra odehrála (uložila)
    ''' </summary>
    Public Property Datum() As String
        Get
            Return _Datum
        End Get
        Set(ByVal value As String)
            _Datum = value
        End Set
    End Property

    Private _Bily As String
    ''' <summary>
    ''' Bílý hráč
    ''' </summary>
    Public Property Bily() As String
        Get
            Return _Bily
        End Get
        Set(ByVal value As String)
            _Bily = value
        End Set
    End Property

    Private _Cerny As String
    ''' <summary>
    ''' Černý hráč
    ''' </summary>
    Public Property Cerny() As String
        Get
            Return _Cerny
        End Get
        Set(ByVal value As String)
            _Cerny = value
        End Set
    End Property

    Private _Vysledek As String
    ''' <summary>
    ''' Výsledek hry
    ''' </summary>
    Public Property Vysledek() As String
        Get
            Return _Vysledek
        End Get
        Set(ByVal value As String)
            _Vysledek = value
        End Set
    End Property

    Private _Notace As String
    ''' <summary>
    ''' Notace (průběh) hry
    ''' </summary>
    Public Property Notace() As String
        Get
            Return _Notace
        End Get
        Set(ByVal value As String)
            _Notace = value
        End Set
    End Property

    ''METHODS''

    ''' <summary>
    ''' Procedura pro načtení dat ze souboru.
    ''' </summary>
    ''' <param name="File">Datový soubor ze kterého budou načtena data.</param>
    ''' <remarks></remarks>
    Public Sub LoadFromFile(ByVal File As String)
        Dim Text As String = My.Computer.FileSystem.ReadAllText(File)

        Datum = Text.Substring(Text.IndexOf("<date>") + 6, Text.IndexOf("</date>") - (Text.IndexOf("<date>") + 6))
        Bily = Text.Substring(Text.IndexOf("<white>") + 7, Text.IndexOf("</white>") - (Text.IndexOf("<white>") + 7))
        Cerny = Text.Substring(Text.IndexOf("<black>") + 7, Text.IndexOf("</black>") - (Text.IndexOf("<black>") + 7))
        Vysledek = Text.Substring(Text.IndexOf("<result>") + 8, Text.IndexOf("</result>") - (Text.IndexOf("<result>") + 8))
        Notace = Text.Substring(Text.IndexOf("<notation>") + 10, Text.IndexOf("</notation>") - (Text.IndexOf("<notation>") + 10))
    End Sub

    ''' <summary>
    ''' Procedura pro zapsání dat do souboru.
    ''' </summary>
    ''' <param name="File">Datový soubor do kterého budou zapsána data.</param>
    ''' <remarks></remarks>
    Public Sub SaveToFile(ByVal File As String)
        My.Computer.FileSystem.WriteAllText(File, _
            "<date>" & Datum & "</date>" & Environment.NewLine & _
            "<white>" & Bily & "</white>" & Environment.NewLine & _
            "<black>" & Cerny & "</black>" & Environment.NewLine & _
            "<result>" & Vysledek & "</result>" & Environment.NewLine & _
            "<notation>" & Notace & "</notation>" & Environment.NewLine, False)

    End Sub

End Class

