﻿Module Game

#Region "Public Variables"

    Public Deska As New HlavniHerniDeska
    Public UInteligence As New HlavniUmelaInteligence


#End Region

#Region "Nová hra"

    Public Sub RESET_GAME_forNotation()

        Main.AI_TimeToMove1.Enabled = False
        Main.AI_TimeToMove2.Enabled = False



        With Deska
            .VymazPole()

            .HracNaTahu = Nothing
            .HracCerny = Nothing
            .HracBily = Nothing

            .BilyTahnul = True
            .BilyRotoval = True

            .CernyTahnul = True
            .CernyRotoval = True

            .BilyCekaNaVyhru = False
            .CernyCekaNaVyhru = False

            .CisloTahu = 0

            .VykresliSoucasnouDesku()
        End With

    End Sub

    Public Sub InitializeP1B(Optional ByVal Notate As Boolean = True)

        Main.AI_TimeToMove1.Enabled = False
        Main.AI_TimeToMove2.Enabled = False

        If GlobalnePouzivanaAI = Nothing Then
            GlobalnePouzivanaAI = InputBox("Není zadána AI co se bude používat, zadejte ji nyní. (1)Naive; (2)MinMax; (3)AlfaBeta;", "Volba AI")
        End If

        With Deska
            .BilyTahnul = False
            .BilyRotoval = True

            .CernyTahnul = False
            .CernyRotoval = True

            .BilyCekaNaVyhru = False
            .CernyCekaNaVyhru = False

            .CisloTahu = 1

            .VymazPole()

            .HracNaTahu = 1

            .HracCerny = 0
            .HracBily = 1

            .VykresliSoucasnouDesku()
        End With

        If Notate = True Then Notation_WriteGameStart("P1B")

        AI_CommitMove_P1(GlobalnePouzivanaAI)

    End Sub

    Public Sub InitializeP1W(Optional ByVal Notate As Boolean = True)

        Main.AI_TimeToMove1.Enabled = False
        Main.AI_TimeToMove2.Enabled = False

        If GlobalnePouzivanaAI = Nothing Then
            GlobalnePouzivanaAI = InputBox("Není zadána AI co se bude používat, zadejte ji nyní. (1)Naive; (2)MinMax; (3)AlfaBeta;", "Volba AI")
        End If

        With Deska
            .BilyTahnul = False
            .BilyRotoval = True

            .CernyTahnul = False
            .CernyRotoval = True

            .BilyCekaNaVyhru = False
            .CernyCekaNaVyhru = False

            .CisloTahu = 1

            .VymazPole()

            .HracNaTahu = 1

            .HracCerny = 1
            .HracBily = 0

            .VykresliSoucasnouDesku()
        End With

        If Notate = True Then Notation_WriteGameStart("P1W")

    End Sub

    Public Sub InitializeP2H(Optional ByVal Notate As Boolean = True)

        Main.AI_TimeToMove1.Enabled = False
        Main.AI_TimeToMove2.Enabled = False

        With Deska
            .BilyTahnul = False
            .BilyRotoval = True

            .CernyTahnul = False
            .CernyRotoval = True

            .BilyCekaNaVyhru = False
            .CernyCekaNaVyhru = False

            .CisloTahu = 1

            .VymazPole()

            .HracNaTahu = 1

            .HracCerny = 0
            .HracBily = 0

            .VykresliSoucasnouDesku()
        End With

        If Notate = True Then Notation_WriteGameStart("P2H")

    End Sub

    Public Sub InitializeP2AI(Optional ByVal Notate As Boolean = True)

        Main.AI_TimeToMove1.Enabled = False
        Main.AI_TimeToMove2.Enabled = False

        MsgBox("Hra může být extrémně rychlá", MsgBoxStyle.OkOnly, "Varování")

        If GlobalnePouzivanaAI = Nothing Then
            GlobalnePouzivanaAI = InputBox("Není zadána AI co se bude používat, zadejte ji nyní. (1)Naive; (2)MinMax; (3)AlfaBeta;", "Volba AI")
        End If

        With Deska
            .BilyTahnul = False
            .BilyRotoval = True

            .CernyTahnul = False
            .CernyRotoval = True

            .BilyCekaNaVyhru = False
            .CernyCekaNaVyhru = False

            .CisloTahu = 1

            .VymazPole()

            .HracNaTahu = 1

            .HracCerny = 1
            .HracBily = 1

            .VykresliSoucasnouDesku()
        End With

        If Notate = True Then Notation_WriteGameStart("P2AI")

        AI_CommitMove_P1(GlobalnePouzivanaAI)

    End Sub

#End Region

#Region "Rotations"

    Public Function ConditionsBlock() As Boolean

        With Deska

            If (.HracNaTahu = 1 And .HracBily = 0 And .BilyRotoval = False) Or (.HracNaTahu = -1 And .HracCerny = 0 And .CernyRotoval = False) Then
                Return True
            Else
                Return False
            End If

        End With

    End Function






#End Region

#Region "Alerts & Errors"

#Region "Alerts"

    Public Sub Alert_Victory(ByVal Player As String)

        Application.DoEvents()
        If Player = "w" Then
            Application.DoEvents()
            MessageBox.Show("Bílý vyhrál.", "Konec hry")
        Else
            Application.DoEvents()
            MessageBox.Show("Černý vyhrál.", "Konec hry")
        End If

    End Sub
    Public Sub Alert_Draw()

        Application.DoEvents()
        MessageBox.Show("Remíza.", "Konec hry")

    End Sub
    Public Sub Alert_Benchmark(ByVal PocetPrubehuHodnoticiFunkce, ByVal Time)

        Application.DoEvents()
        MessageBox.Show("Benchmark byl úspěšně dokončen", "Benchmark")
        MessageBox.Show("Kalkulací bylo celkem provedeno : " & PocetPrubehuHodnoticiFunkce, "Benchmark")
        MessageBox.Show("Kalkulací průměrně za sekundu : " & CInt(PocetPrubehuHodnoticiFunkce / Time.TotalSeconds), "Benchmark")
        MessageBox.Show("Celkový čas potřebný pro provedení benchmarku byl : " & CInt(Time.TotalSeconds) & " sekund", "Benchmark")

    End Sub
    Public Sub Alert_Restart()
        MessageBox.Show("Hra musí být restartována pro plnou funkčnost změn.", "Změna nastavení", MessageBoxButtons.OK, MessageBoxIcon.Warning)
    End Sub


#End Region

#Region "Errors"

    Public Sub Alert_Error1()

        Application.DoEvents()
        MessageBox.Show("Chyba: Public Function RotationText(ByVal Index As Byte) As String; incorrect parameter supplied", "Error1")

    End Sub
    Public Sub Alert_Error2()

        Application.DoEvents()
        MessageBox.Show("Chyba: ERROR field is not empty; incorrect parameter supplied", "Error2")

    End Sub

#End Region

#End Region

#Region "Kontrola 5"

#Region "Nedeterministická kontrola 5"

    Public Function ND_Check_For_5_VERTICAL_DOWN(ByVal StartField As Byte, ByVal XBoard() As SByte) As Boolean

        Dim CheckForSymbol As SByte = XBoard(StartField)

        If CheckForSymbol = 0 Then Return False

        For a As Byte = 0 To 4
            If XBoard(StartField + a * 6) <> CheckForSymbol Then
                Return False
            End If
        Next

        Return True

    End Function
    Public Function ND_Check_For_5_HORIZONTAL_RIGHT(ByVal StartField As Byte, ByVal XBoard() As SByte) As Boolean

        Dim CheckForSymbol As SByte = XBoard(StartField)

        If CheckForSymbol = 0 Then Return False

        For a As Byte = 0 To 4
            If XBoard(StartField + a) <> CheckForSymbol Then
                Return False
            End If
        Next

        Return True

    End Function
    Public Function ND_Check_For_5_VH1_DOWNRIGHT(ByVal StartField As Byte, ByVal XBoard() As SByte) As Boolean

        Dim CheckForSymbol As SByte = XBoard(StartField)

        If CheckForSymbol = 0 Then Return False

        For a As Byte = 0 To 4
            If XBoard(StartField + a * 7) <> CheckForSymbol Then
                Return False
            End If
        Next

        Return True

    End Function
    Public Function ND_Check_For_5_VH2_UPRIGHT(ByVal StartField As Byte, ByVal XBoard() As SByte) As Boolean

        Dim CheckForSymbol As SByte = XBoard(StartField)

        If CheckForSymbol = 0 Then Return False

        For a As Byte = 0 To 4
            If XBoard(StartField - 5 * a) <> CheckForSymbol Then
                Return False
            End If
        Next

        Return True

    End Function

    Public Function ND_Check_For_5_ALL_VERTICAL() As Boolean

        For a As Byte = 0 To 11

            If ND_Check_For_5_VERTICAL_DOWN(a, Deska.Pole) = True Then Return True

        Next

        Return False

    End Function
    Public Function ND_Check_For_5_ALL_HORIZONTAL() As Boolean

        For a As Byte = 0 To 5

            If ND_Check_For_5_HORIZONTAL_RIGHT(a * 6, Deska.Pole) = True Then Return True
            If ND_Check_For_5_HORIZONTAL_RIGHT(a * 6 + 1, Deska.Pole) = True Then Return True

        Next

        Return False

    End Function
    Public Function ND_Check_For_5_ALL_VH() As Boolean

        For a As Byte = 0 To 1

            If ND_Check_For_5_VH1_DOWNRIGHT(a * 6, Deska.Pole) = True Then Return True
            If ND_Check_For_5_VH1_DOWNRIGHT(a * 6 + 1, Deska.Pole) = True Then Return True
            If ND_Check_For_5_VH2_UPRIGHT(a * 6 + 24, Deska.Pole) = True Then Return True
            If ND_Check_For_5_VH2_UPRIGHT(a * 6 + 25, Deska.Pole) = True Then Return True

        Next

        Return False

    End Function

    Public Function ND_Check_For_5_FINAL() As Boolean

        If ND_Check_For_5_ALL_HORIZONTAL() = True Then Return True
        If ND_Check_For_5_ALL_VERTICAL() = True Then Return True
        If ND_Check_For_5_ALL_VH() = True Then Return True

        Return False

    End Function

    Public Function AI_Check_For_5_FINAL(ByVal AI_Board() As SByte) As Boolean

        For a As Byte = 0 To 5

            If ND_Check_For_5_HORIZONTAL_RIGHT(a * 6, AI_Board) = True Then Return True
            If ND_Check_For_5_HORIZONTAL_RIGHT(a * 6 + 1, AI_Board) = True Then Return True

        Next
        For a As Byte = 0 To 11

            If ND_Check_For_5_VERTICAL_DOWN(a, AI_Board) = True Then Return True

        Next
        For a As Byte = 0 To 1

            If ND_Check_For_5_VH1_DOWNRIGHT(a * 6, AI_Board) = True Then Return True
            If ND_Check_For_5_VH1_DOWNRIGHT(a * 6 + 1, AI_Board) = True Then Return True
            If ND_Check_For_5_VH2_UPRIGHT(a * 6 + 24, AI_Board) = True Then Return True
            If ND_Check_For_5_VH2_UPRIGHT(a * 6 + 25, AI_Board) = True Then Return True

        Next

        Return False

    End Function

#End Region

#Region "Deterministická kontrola 5"

    Public Function PD_Check_For_5_VERTICAL_DOWN(ByVal FieldIndex As Byte, ByVal XBoard() As SByte, ByVal PlayerToBeCheckedFor5 As SByte) As Boolean

        If PlayerToBeCheckedFor5 = 0 Then Return False

        For a As Byte = 0 To 4
            If XBoard(FieldIndex + 6 * a) <> PlayerToBeCheckedFor5 Then
                Return False
            End If
        Next

        Return True

    End Function
    Public Function PD_Check_For_5_HORIZONTAL_RIGHT(ByVal FieldIndex As Byte, ByVal XBoard() As SByte, ByVal PlayerToBeCheckedFor5 As SByte) As Boolean

        If PlayerToBeCheckedFor5 = 0 Then Return False

        For a As Byte = 0 To 4
            If XBoard(FieldIndex + a) <> PlayerToBeCheckedFor5 Then
                Return False
            End If
        Next

        Return True

    End Function
    Public Function PD_Check_For_5_VH1_DOWNRIGHT(ByVal FieldIndex As Byte, ByVal XBoard() As SByte, ByVal PlayerToBeCheckedFor5 As SByte) As Boolean

        If PlayerToBeCheckedFor5 = 0 Then Return False

        For a As Byte = 0 To 4
            If XBoard(FieldIndex + 7 * a) <> PlayerToBeCheckedFor5 Then
                Return False
            End If
        Next

        Return True

    End Function
    Public Function PD_Check_For_5_VH2_UPRIGHT(ByVal FieldIndex As Byte, ByVal XBoard() As SByte, ByVal PlayerToBeCheckedFor5 As SByte) As Boolean

        If PlayerToBeCheckedFor5 = 0 Then Return False

        For a As Byte = 0 To 4
            If XBoard(FieldIndex - 5 * a) <> PlayerToBeCheckedFor5 Then
                Return False
            End If
        Next

        Return True

    End Function

    Public Function PD_Check_For_5_ALL_VERTICAL(ByVal PlayerToBeCheckedFor5 As SByte) As Boolean

        For a As Byte = 0 To 11

            If PD_Check_For_5_VERTICAL_DOWN(a, Deska.Pole, PlayerToBeCheckedFor5) = True Then Return True

        Next

        Return False

    End Function
    Public Function PD_Check_For_5_ALL_HORIZONTAL(ByVal PlayerToBeCheckedFor5 As SByte) As Boolean

        For a As Byte = 0 To 5

            If PD_Check_For_5_HORIZONTAL_RIGHT(a * 6, Deska.Pole, PlayerToBeCheckedFor5) = True Then Return True
            If PD_Check_For_5_HORIZONTAL_RIGHT(a * 6 + 1, Deska.Pole, PlayerToBeCheckedFor5) = True Then Return True

        Next

        Return False

    End Function
    Public Function PD_Check_For_5_ALL_VH(ByVal PlayerToBeCheckedFor5 As SByte) As Boolean

        For a As Byte = 0 To 1

            If PD_Check_For_5_VH1_DOWNRIGHT(a * 6, Deska.Pole, PlayerToBeCheckedFor5) = True Then Return True
            If PD_Check_For_5_VH1_DOWNRIGHT(a * 6 + 1, Deska.Pole, PlayerToBeCheckedFor5) = True Then Return True
            If PD_Check_For_5_VH2_UPRIGHT(a * 6 + 24, Deska.Pole, PlayerToBeCheckedFor5) = True Then Return True
            If PD_Check_For_5_VH2_UPRIGHT(a * 6 + 25, Deska.Pole, PlayerToBeCheckedFor5) = True Then Return True

        Next

        Return False

    End Function

    Public Function PD_Check_For_5_FINAL(ByVal PlayerToBeCheckedFor5 As SByte) As Boolean

        If PD_Check_For_5_ALL_HORIZONTAL(PlayerToBeCheckedFor5) = True Then Return True
        If PD_Check_For_5_ALL_VERTICAL(PlayerToBeCheckedFor5) = True Then Return True
        If PD_Check_For_5_ALL_VH(PlayerToBeCheckedFor5) = True Then Return True

        Return False

    End Function

    Public Function AI_PD_Check_For_5_FINAL(ByVal AI_Board() As SByte, ByVal PlayerToCheck As SByte) As Boolean

        For a As Byte = 0 To 5

            If PD_Check_For_5_HORIZONTAL_RIGHT(a * 6, AI_Board, PlayerToCheck) = True Then Return True
            If PD_Check_For_5_HORIZONTAL_RIGHT(a * 6 + 1, AI_Board, PlayerToCheck) = True Then Return True

        Next
        For a As Byte = 0 To 11

            If PD_Check_For_5_VERTICAL_DOWN(a, AI_Board, PlayerToCheck) = True Then Return True

        Next
        For a As Byte = 0 To 1

            If PD_Check_For_5_VH1_DOWNRIGHT(a * 6, AI_Board, PlayerToCheck) = True Then Return True
            If PD_Check_For_5_VH1_DOWNRIGHT(a * 6 + 1, AI_Board, PlayerToCheck) = True Then Return True
            If PD_Check_For_5_VH2_UPRIGHT(a * 6 + 24, AI_Board, PlayerToCheck) = True Then Return True
            If PD_Check_For_5_VH2_UPRIGHT(a * 6 + 25, AI_Board, PlayerToCheck) = True Then Return True

        Next

        Return False

    End Function

#End Region

    '#Region "Smaž danou 5"

    '    Public Sub Delete5(ByRef AI_Board() As SByte)
    '        For a As Byte = 0 To 5

    '            If ND_Check_For_5_HORIZONTAL_RIGHT(a * 6, AI_Board) = True Then
    '                Delete5_HORIZONTAL_RIGHT(a * 6, AI_Board)
    '            End If
    '            If ND_Check_For_5_HORIZONTAL_RIGHT(a * 6 + 1, AI_Board) = True Then
    '                Delete5_HORIZONTAL_RIGHT(a * 6 + 1, AI_Board)
    '            End If

    '        Next
    '        For a As Byte = 0 To 11

    '            If ND_Check_For_5_VERTICAL_DOWN(a, AI_Board) = True Then
    '                Delete5_VERTICAL_DOWN(a, AI_Board)
    '            End If

    '        Next
    '        For a As Byte = 0 To 1

    '            If ND_Check_For_5_VH1_DOWNRIGHT(a * 6, AI_Board) = True Then
    '                Delete5_VH1_DOWNRIGHT(a * 6, AI_Board)
    '            End If
    '            If ND_Check_For_5_VH1_DOWNRIGHT(a * 6 + 1, AI_Board) = True Then
    '                Delete5_VH1_DOWNRIGHT(a * 6 + 1, AI_Board)
    '            End If
    '            If ND_Check_For_5_VH2_UPRIGHT(a * 6 + 24, AI_Board) = True Then
    '                Delete5_VH2_UPRIGHT(a * 6 + 24, AI_Board)
    '            End If
    '            If ND_Check_For_5_VH2_UPRIGHT(a * 6 + 25, AI_Board) = True Then
    '                Delete5_VH2_UPRIGHT(a * 6 + 25, AI_Board)
    '            End If

    '        Next
    '    End Sub

    '    Public Sub Delete5_VERTICAL_DOWN(ByVal StartField As Byte, ByRef XBoard() As SByte)

    '        For a As Byte = 0 To 4
    '            XBoard(StartField + a * 6) = 0
    '        Next

    '    End Sub
    '    Public Sub Delete5_HORIZONTAL_RIGHT(ByVal StartField As Byte, ByRef XBoard() As SByte)

    '        For a As Byte = 0 To 4
    '            XBoard(StartField + a) = 0
    '        Next

    '    End Sub
    '    Public Sub Delete5_VH1_DOWNRIGHT(ByVal StartField As Byte, ByRef XBoard() As SByte)

    '        For a As Byte = 0 To 4
    '            XBoard(StartField + a * 7) = 0
    '        Next

    '    End Sub
    '    Public Sub Delete5_VH2_UPRIGHT(ByVal StartField As Byte, ByRef XBoard() As SByte)

    '        For a As Byte = 0 To 4
    '            XBoard(StartField - 5 * a) = 0
    '        Next

    '    End Sub

    '#End Region

#End Region

#Region "Operace s pozicí"


    Public Function BoardOperations_ExtremizeValue(ByVal Value As SByte) As SByte

        Select Case Value
            Case 1
                Return 2
            Case -1
                Return -2
        End Select

    End Function

    Public Sub HaltGame()
        With Deska
            .BilyRotoval = True
            .BilyTahnul = True
            .CernyRotoval = True
            .CernyTahnul = True
        End With
    End Sub

    Public Sub CommitMove(ByVal FieldIndex As Byte, Optional ByVal Notate As Boolean = True, Optional ByVal PlayerOnly As SByte = 0)

        With Deska

            If .Pole(FieldIndex) = 0 Then
                If .HracNaTahu = 1 Then
                    If .HracBily = PlayerOnly And .BilyTahnul = False Then
                        .Pole(FieldIndex) = .HracNaTahu

                        .VykresliPole(FieldIndex, .Pole(FieldIndex))

                        If Notate = True Then Notation_WriteMove("w", FieldIndex - (6 * (FieldIndex \ 6)), FieldIndex \ 6)

                        If PD_Check_For_5_FINAL(.HracNaTahu) = True Then
                            If .CernyCekaNaVyhru = False Then
                                Alert_Victory("w")
                                HaltGame()
                            Else
                                Alert_Draw()
                                HaltGame()
                            End If
                        Else
                            If .CernyCekaNaVyhru = False Then
                                .BilyRotoval = False
                                .BilyTahnul = True
                            Else
                                Alert_Victory("b")
                                HaltGame()
                            End If
                        End If

                        If .HracCerny = 1 Then
                            'AI MODULE
                            Main.AI_TimeToMove2.Enabled = True
                        End If
                    End If
                ElseIf .HracNaTahu = -1 Then
                    If .HracCerny = PlayerOnly And .CernyTahnul = False Then
                        .Pole(FieldIndex) = .HracNaTahu

                        .VykresliPole(FieldIndex, .Pole(FieldIndex))

                        If Notate = True Then Notation_WriteMove("b", FieldIndex - (6 * (FieldIndex \ 6)), FieldIndex \ 6)

                        If PD_Check_For_5_FINAL(.HracNaTahu) = True Then
                            If .BilyCekaNaVyhru = False Then
                                Alert_Victory("b")
                                HaltGame()
                            Else
                                Alert_Draw()
                                HaltGame()
                            End If
                        Else
                            If .BilyCekaNaVyhru = False Then
                                .CernyRotoval = False
                                .CernyTahnul = True
                            Else
                                Alert_Victory("w")
                                HaltGame()
                            End If
                        End If

                        If .HracBily = 1 Then
                            'AI MODULE
                            Main.AI_TimeToMove1.Enabled = True
                        End If
                    End If
                End If
            End If

        End With

    End Sub

#End Region

#Region "Notace - Mod"

    Public Sub Notation_WriteMove(ByVal player As String, ByVal x As Integer, ByVal y As Integer)

        Notation.ListBox1.Items.Add("Tah " & Deska.CisloTahu & " - " & player & " x:" & x & " y:" & y)

    End Sub

    Public Sub Notation_WriteRotation(ByVal player As String, ByVal quartal As Byte, ByVal direction As String)

        Notation.ListBox1.Items.Add("Rotace " & Deska.CisloTahu & " - " & player & " Q:" & quartal & " D:" & direction)
        Deska.CisloTahu += 1

    End Sub

    Public Sub Notation_WriteGameStart(ByVal type As String)

        Notation.ListBox1.Items.Add("Start" & " - " & "type:" & type)

    End Sub

#End Region








    Public RotatingSleepTime As Short = 1000
    Public ImagePath As String
    Public DatabasePath As String

    Public Sub ChangeGraphicsSet(Optional ByVal GraphicsSet As String = "")

        If My.Settings.Path_Exe = "NotSet" Then My.Settings.Path_Exe = Application.StartupPath()

        If GraphicsSet = "" Then
            ImagePath = My.Settings.Path_Exe & "\Graphics\" & My.Settings.Graphics_to_use & "\"
        Else
            My.Settings.Graphics_to_use = GraphicsSet
            ImagePath = My.Settings.Path_Exe & "\Graphics\" & My.Settings.Graphics_to_use & "\"
        End If

        Deska.VykresliSoucasnouDesku()
        Deska.Rotations_Exit_Q1R()
        Deska.Rotations_Exit_Q1L()
        Deska.Rotations_Exit_Q2R()
        Deska.Rotations_Exit_Q2L()
        Deska.Rotations_Exit_Q3R()
        Deska.Rotations_Exit_Q3L()
        Deska.Rotations_Exit_Q4R()
        Deska.Rotations_Exit_Q4L()
    End Sub




   














    Public Zaznamy() As ZaznamHry

    Public Sub LoadDatabase()

        With My.Computer.FileSystem

            Dim VelikostDatabaze As Integer = .GetFiles(DatabasePath).Count - 1

            ReDim Zaznamy(VelikostDatabaze)

            For a = 0 To VelikostDatabaze
                Zaznamy(a) = New ZaznamHry
                Zaznamy(a).LoadFromFile(.GetFiles(DatabasePath)(a))

                Dim zapis As New ListViewItem
                zapis.Text = Zaznamy(a).Datum.ToString
                zapis.SubItems.Add(Zaznamy(a).Bily)
                zapis.SubItems.Add(Zaznamy(a).Cerny)
                zapis.SubItems.Add(Zaznamy(a).Vysledek)

                Database.ListView1.Items.Add(Zapis)
            Next

        End With





    End Sub






End Module
